(function($){
    $(function () {

        /* PAGE VIEW SETTINGS */
        getPageViewSettings();
        function getPageViewSettings() {

            if($("#page-view-settings").length === 0){
                return;
            }

            $.ajax({
                cache: false,
                dataType: "json",
                error: function (XMLHttpRequest, textStatus, errorThrown) {

                },
                success: function (data) {
                    if(data.showPageView){
                        $("#cbShowPageView").prop("checked", true);
                    }else{
                        $("#cbShowPageView").prop("checked", false);
                    }

                    if(data.showPageViewDetail){
                        $("#cbShowPageViewDetail").prop("checked", true);
                    }else{
                        $("#cbShowPageViewDetail").prop("checked", false);
                    }

                    if(data.allowSpaceAdmin){
                        $("#cbAllowSpaceAdmin").prop("checked", true);
                    }else{
                        $("#cbAllowSpaceAdmin").prop("checked", false);
                    }

                    if(data.disableTrackingUserName){
                        $("#cbDisableTrackingUserName").prop("checked", true);
                    }else{
                        $("#cbDisableTrackingUserName").prop("checked", false);
                    }

                    $("#google-api-key").val(data.googleApiKey);

                    if(data.trackAllSpaces){
                        $("#all-spaces").prop("checked", true);
                        $("#space-keys").prop("disabled", true);
                    }
                    else{
                        $("#selected-spaces").prop("checked", true);
                        $("#space-keys").prop("disabled", false);
                    }

                    $("#space-keys").val(data.trackedSpaces);
                    $("#space-names").val(data.trackedSpaceNames);
                    $("#ip-geolocation-api").val(data.ipGeolocationApi);

                    $("#access-groups").val(data.accessGroups);
                    $("#access-users").val(data.accessUsers);

                    createSpaceSelect($("#space-keys"));
                    createGroupSelect($("#access-groups"));
                    createUserSelect($("#access-users"));

                },
                type: "GET",
                timeout: PageTrackingUtils.ajaxTimeout,
                url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/page-view-settings")
            });
        }

        $("#cbShowPageView").click(function (e) {
            if($(this).prop("checked")){
                $("#cbShowPageViewDetail").prop("disabled", false);
            }
            else{
                $("#cbShowPageViewDetail").prop("checked", false);
                $("#cbShowPageViewDetail").prop("disabled", true);
            }
        });

        $("#all-spaces").click(function (e) {
            $("#space-keys").prop("disabled", true);
        });

        $("#selected-spaces").click(function (e) {
            $("#space-keys").prop("disabled", false);
        });

        $("#save-setting-button").click(function (e) {

            var showPageView = $("#cbShowPageView").prop("checked");
            var showPageViewDetail = showPageView && $("#cbShowPageViewDetail").prop("checked");
            var allowSpaceAdmin = $("#cbAllowSpaceAdmin").prop("checked");
            var disableTrackingUserName = $("#cbDisableTrackingUserName").prop("checked");
            var trackAllSpaces = $("#all-spaces").prop("checked");
            var trackedSpaces = $("#space-keys").val();
            var googleApiKey = $("#google-api-key").val();
            var ipGeolocationApi = $("#ip-geolocation-api").val();
            var accessGroups = $("#access-groups").val();
            var accessUsers = $("#access-users").val();

            $.ajax({
                cache: false,
                data: {
                    showPageView: showPageView,
                    showPageViewDetail: showPageViewDetail,
                    allowSpaceAdmin : allowSpaceAdmin,
                    disableTrackingUserName: disableTrackingUserName,
                    googleApiKey : googleApiKey,
                    trackAllSpaces: trackAllSpaces,
                    trackedSpaces: trackedSpaces,
                    ipGeolocationApi: ipGeolocationApi,
                    accessGroups: accessGroups,
                    accessUsers: accessUsers
                },
                dataType: "json",
                type: "PUT",
                error: function(jqXHR, textStatus, errorThrown) {
                    console.log(showPageView);
                    window.location.reload();
                },
                success: function(data) {
                    //if(data.success){
                    $("#setting-message").show().fadeOut(2000);
                    //}
                },
                timeout: PageTrackingUtils.ajaxTimeout,
                url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/page-view-settings")
            });
        });

        $("#cancel-setting-button").click(function (e) {
            e.preventDefault();
            window.location.reload();
        });

        function createSpaceSelect (element) {
            var lastResults = [];

            element.removeClass("hidden").auiSelect2({
                multiple: true,
                placeholder: "",
                maximumInputLength: 150,
                quietMillis: 200,
                ajax: {
                    url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/search-spaces"),
                    data: function(searchTerm) {
                        searchTerm = $.trim(searchTerm);

                        return {
                            query: $.trim(searchTerm)
                        }
                    },
                    results: function (data) {

                        lastResults = _.map(data.result, function(space) {
                            return {
                                id: space.key,
                                text: space.name,
                                metadata: "(" + space.name + ")",
                                //userImage: user.thumbnailLink !== undefined ? user.thumbnailLink.href : ""
                            }
                        });
                        return {
                            results: lastResults
                        };
                    },
                    quietMillis: 300
                },
                createSearchChoice: function(term, data) {

                    var trimmedTerm = $.trim(term);
                    var itemComparator = function (item) { return item.text.localeCompare(trimmedTerm) == 0; };

                    // createSearchChoice is called by the default tokenizer when typing "," or " "
                    // we need to check if the term was returned during the previous search
                    if (_.filter(lastResults, itemComparator).length > 0) {
                        return {
                            id: trimmedTerm,
                            text: trimmedTerm
                        };
                    }
                },
                initSelection: function(element, callback) {
                    var data = [];

                    var spaceKeys = element.val().split(",");
                    var spaceNames = $("#space-names").val().split(";#");

                    for(var i = 0; i < spaceKeys.length; i ++){
                        var spaceName = spaceKeys[i];
                        if(i < spaceNames.length){
                            spaceName = spaceNames[i]
                        }
                        data.push({id: spaceKeys[i], text: spaceName });
                    }
                    callback(data);
                },
                formatResult: function (result, container, query, escapeMarkup){
                    var formattedResult = $.fn.select2.defaults.formatResult(result, container, query, escapeMarkup);
                    return formattedResult;
                },
                sortResults: function (results, container, query) {
                    return results;
                }
            });
        }

        //region CREATE USER SELECT
        function createUserSelect (element) {
            var lastResults = [];

            element.removeClass("hidden").auiSelect2({
                multiple: true,
                tokenSeparators: [","],
                maximumSelectionLength: 5,
                placeholder: "",
                maximumInputLength: 150,
                quietMillis: 200,
                ajax: {
                    url: AJS.contextPath() + "/rest/prototype/1/search/user.json?max-results=20",
                    data: function(searchTerm) {

                        searchTerm = $.trim(searchTerm);
                        if (searchTerm.length < 2) {
                            searchTerm = "_"; // by pass query value
                        }

                        return {
                            query: $.trim(searchTerm)
                        }
                    },
                    results: function (data) {
                        lastResults = _.map(data.result, function(user) {
                            return {
                                id: user.username,
                                text: user.username,
                                metadata: "(" + user.title + ")",
                                userImage: user.thumbnailLink !== undefined ? user.thumbnailLink.href : ""
                            }
                        });
                        return {
                            results: lastResults
                        };
                    },
                    quietMillis: 300
                },
                createSearchChoice: function(term, data) {

                    var trimmedTerm = $.trim(term);
                    var itemComparator = function (item) { return item.text.localeCompare(trimmedTerm) == 0; };

                    // createSearchChoice is called by the default tokenizer when typing "," or " "
                    // we need to check if the term was returned during the previous search
                    if (_.filter(lastResults, itemComparator).length > 0) {
                        return {
                            id: trimmedTerm,
                            text: trimmedTerm
                        };
                    }
                },
                initSelection: function(element, callback) {
                    var data = [];
                    $(element.val().split(",")).each(function () {
                        data.push({id: this, text: this});
                    });
                    callback(data);
                },
                formatResult: function (result, container, query, escapeMarkup)
                {
                    var formattedResult = $.fn.select2.defaults.formatResult(result, container, query, escapeMarkup);

                    if (result.metadata !== undefined)
                    {
                        formattedResult += "<span class='pv-tags-info'>" + result.metadata + "</span>";
                    }

                    if(result.userImage != undefined){
                        formattedResult = "<img class='thumbnail' src='" + result.userImage +"' />" + formattedResult;
                    }

                    return formattedResult;
                },
                sortResults: function (results, container, query) {
                    return results;
                }
            });
        }

        //endregion


        //region CREATE GROUP SELECT
        function createGroupSelect (element) {
            var lastResults = [];

            element.removeClass("hidden").auiSelect2({
                multiple: true,
                tokenSeparators: [","],
                maximumSelectionLength: 5,
                placeholder: "",
                maximumInputLength: 150,
                quietMillis: 200,
                ajax: {
                    url: AJS.contextPath() + "/rest/prototype/1/search/group.json?max-results=20",
                    data: function(searchTerm) {

                        searchTerm = $.trim(searchTerm);

                        return {
                            query: $.trim(searchTerm)
                        }
                    },
                    results: function (data) {
                        lastResults = _.map(data.result, function(group) {
                            return {
                                id: group.name,
                                text: group.name,
                                userImage: AJS.contextPath() + "/images/icons/avatar_group_48.png"
                            }
                        });
                        return {
                            results: lastResults
                        };
                    },
                    quietMillis: 300
                },
                createSearchChoice: function(term, data) {

                    var trimmedTerm = $.trim(term);
                    var itemComparator = function (item) { return item.text.localeCompare(trimmedTerm) == 0; };

                    // createSearchChoice is called by the default tokenizer when typing "," or " "
                    // we need to check if the term was returned during the previous search
                    if (_.filter(lastResults, itemComparator).length > 0) {
                        return {
                            id: trimmedTerm,
                            text: trimmedTerm
                        };
                    }
                },
                initSelection: function(element, callback) {
                    var data = [];
                    $(element.val().split(",")).each(function () {
                        data.push({id: this, text: this});
                    });
                    callback(data);
                },
                formatResult: function (result, container, query, escapeMarkup)
                {
                    var formattedResult = $.fn.select2.defaults.formatResult(result, container, query, escapeMarkup);

                    if(result.userImage != undefined){
                        formattedResult = "<img class='thumbnail' src='" + result.userImage +"' />" + formattedResult;
                    }

                    return formattedResult;
                },
                sortResults: function (results, container, query) {

                    return results;
                }
            });
        }
        //endregion

        /*DISABLE TRACKING PAGES */
        getDisableTrackingPages();
        function getDisableTrackingPages() {

            $.ajax({
                cache: false,
                dataType: "json",
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    $("#page-tracking-loading").hide();
                },
                success: function (data) {

                    var result = "";
                    if (data.status === true){
                        var pages = data.pages;

                        var row = "";

                        for(var i = 0; i< pages.length; i++){


                            var pageLink = "<a target='_blank' href='"

                                + Confluence.getContextPath() + pages[i].pageUrl + "'>"

                                + PageTrackingUtils.escapeHtml(pages[i].pageName) +"</a>";

                            var spaceLink = "<a target='_blank' href='"

                                + Confluence.getContextPath()+ "/display/" + pages[i].spaceKey + "'>"

                                + PageTrackingUtils.escapeHtml(pages[i].spaceName) +"</a>";



                            row += "<tr>";

                            row += "<td>" + (i + 1)  + "</td>";

                            row += "<td>" + pageLink  + "</td>";
                            row += "<td>" + spaceLink  + "</td>";



                            row += "<td>" + "<a class='enable-page-view-tracking disable' href='#' data='" + pages[i].pageId + "'>Enable</a>" + "</td>";

                            row+="</tr>";


                        }

                        result+= row;
                    }

                    $("#page-disable-tracking-detail table tbody").html(result);
                    $("#page-tracking-loading").hide();

                    if(data.pages.length > 0){
                        $("#page-disable-tracking-detail").show();
                    }

                },
                type: "GET",
                timeout: PageTrackingUtils.ajaxTimeout,
                url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/page-disable-tracking")
            });
        }

        $("#page-disable-tracking-detail").on("click", ".enable-page-view-tracking", function(e) {
            e.preventDefault();

            var pageId = $(this).attr("data");
            var status = false;

            if($(this).hasClass("enable")){
                $(this).removeClass("enable").addClass("disable").html("Enable");
                $("#page-tracking-table").hide();
                status = false;
            }
            else {
                $(this).removeClass("disable").addClass("enable").html("Disable");
                $("#page-tracking-table").show();
                status = true;
            }

            $.ajax({
                cache: false,
                data: {pageId: pageId, status : status},
                dataType: "json",
                type: "PUT",
                error: function(jqXHR, textStatus, errorThrown) {
                    console.log("ERROR: " + pageId)
                },
                success: function(data) {
                    if(data.status){
                        console.log(pageId);
                    }
                },
                timeout: PageTrackingUtils.ajaxTimeout,
                url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/update-tracking-status")
            });

        });
    });
}(AJS.$));