(function($){
    $(function () {

        getSpaceInformation();
        //If you cannot get space key from Confluence meta, you need send request to server
        function getSpaceInformation() {

            var spaceKey = AJS.Meta.get("space-key");
            if(spaceKey !== undefined){
                return;
            }

            var pageId = getPageId();
            if(pageId === undefined){
                return;
            }

            $.ajax({
                cache: false,
                data: {
                    pageId: pageId
                },
                dataType: "json",
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                },
                success: function (data) {
                    $("body").attr("current-space-key", data.spaceKey);
                },
                type: "GET",
                timeout: PageTrackingUtils.ajaxTimeout,
                url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/space-info")
            });
        }

        loadPageViewCount();
        function loadPageViewCount(){

            var pageId = getPageId();
            if(pageId === undefined) {
                return;
            }

            $.ajax({
                cache: false,
                data: {pageId: pageId},
                dataType: "json",
                error: function (XMLHttpRequest, textStatus, errorThrown) {

                },
                success: function (data) {

                    var counter = data.v;
                    counter = counter == 0 ? 1 : counter; // Page just created will have 1 view
                    var result = counter + " " + (counter > 1 ? "views" : "view") ;
                    var isAdmin = data.ad;
                    var isSpaceAdmin = data.sa;
                    var hasViewPermission = data.hvp;
                    var showPageView = data.spv;
                    var showPageViewDetail = showPageView && data.spvd;

                    //createIncreasePageViewFlag(counter, showPageView);

                    $("#page-metadata-banner #view-banner-stats span").html(result);

                    var $pageMetaDataModificationInfo = $(".page-metadata .page-metadata-modification-info");

                    if(showPageView) {
                        var timeViews = ", <a class='view-times' href='#'>viewed " + counter + (counter > 1 ? " times" : " time") + "</a>";


                        if($pageMetaDataModificationInfo.length > 0) {
                            var html = $pageMetaDataModificationInfo.html().trim() + timeViews.trim();
                            $pageMetaDataModificationInfo.html(html);
                        }

                        $("#page-metadata-banner #view-banner-stats").removeClass("elite-soft-page-view");
                    }

                    if(isAdmin || isSpaceAdmin || hasViewPermission || showPageViewDetail){
                        $("#page-metadata-banner #view-banner-stats span").addClass("show-detail");
                        $(".view-times", $pageMetaDataModificationInfo).addClass("show-detail");

                        var pageId = getPageId(); //AJS.Meta.get("page-id");
                        var spaceKey = getSpaceKey(); //AJS.Meta.get("space-key");
                        var pageViewDetailUrl = AJS.contextPath() + "/page-tracking/page-view-detail.action?pageId=" + pageId + "&spaceKey=" + spaceKey;

                        $("#page-metadata-banner #view-banner-stats").attr("href", pageViewDetailUrl);
                        $(".view-times", $pageMetaDataModificationInfo).attr("href", pageViewDetailUrl);
                    }

                },
                type: "GET",
                timeout: PageTrackingUtils.ajaxTimeout,
                url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/update-view")
            });
        }

        // PAGE view
        //increasePageViewCount();
        function increasePageViewCount(){

            /*var pageId = AJS.Meta.get("page-id");
            if(pageId === undefined)
            {
                return;
            }

            // Use for scroll view port
            var pageId = $("body").attr("pageid");
            if(pageId === undefined)
            {
                return;
            }
            */

            var pageId = getPageId();
            if(pageId === undefined){
                return;
            }

            $.ajax({
                cache: false,
                data: {pageId: pageId},
                dataType: "json",
                type: "PUT",
                error: function(jqXHR, textStatus, errorThrown) {
                    console.log("ERROR: " + pageId)
                },
                success: function(data) {
                    if(data.status){
                        console.log(pageId);
                    }
                },
                timeout: PageTrackingUtils.ajaxTimeout,
                url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/page-view")
            });
        }

        // MAP view
        increasePageMapViewCount();
        function increasePageMapViewCount(){

            try {

                var pageId = getPageId(); //AJS.Meta.get("page-id");
                if (pageId === undefined) {
                    return;
                }

                $.ajax({
                    cache: false,
                    dataType: "json",
                    error: function (XMLHttpRequest, textStatus, errorThrown) {

                    },
                    success: function (data) {

                        if(data.gak == ""){
                            //console.log("Don't update map because there is no configuration for Google Maps");
                            return;
                        }

                        var freegeoUrl = data.iga; // "https://reallyfreegeoip.org/json/"; // AJS.params.baseUrl.indexOf("https") == 0 ? "https://freegeoip.net/json/" : "http://freegeoip.net/json/";

                        $.ajax({
                            cache: false,
                            dataType: "json",
                            error: function (XMLHttpRequest, textStatus, errorThrown) {

                            },
                            success: function (data) {
                                var mapObject = {
                                    pageId: pageId,
                                    countryCode: data.country_code,
                                    countryName: data.country_name,
                                    regionCode: data.region_code,
                                    regionName: data.region_name,
                                    city: data.city,
                                    latitude: data.latitude,
                                    longitude: data.longitude
                                };

                                $.ajax({
                                    cache: false,
                                    data: mapObject,
                                    dataType: "json",
                                    type: "PUT",
                                    error: function (jqXHR, textStatus, errorThrown) {
                                        console.log("ERROR: " + pageId)
                                    },
                                    success: function (data) {
                                        if (data.status) {
                                            console.log(pageId);
                                        }
                                    },
                                    timeout: PageTrackingUtils.ajaxTimeout,
                                    url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/map-view")
                                });

                            },
                            type: "GET",
                            timeout: PageTrackingUtils.ajaxTimeout,
                            url: freegeoUrl
                        });
                    },
                    type: "GET",
                    timeout: PageTrackingUtils.ajaxTimeout,
                    url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/pvms")
                });


            }catch (err){
                console.log("Error when updating map view count.");
            }
        }

        //increasePageViewCountEvery1Hour();
        function increasePageViewCountEvery1Hour() {
            try{
                if(typeof(Storage) !== "undefined") {

                    var day = new Date();
                    var hour = day.getHours();

                    var item = "pageId-" + AJS.Meta.get("page-id");

                    if (localStorage.getItem(item)) {
                        var lastHour = localStorage.getItem(item);
                        if(lastHour != hour){
                            increasePageViewCount();
                            console.log(1);
                        }

                        localStorage.setItem(item, hour);
                    } else {
                        localStorage.setItem(item, hour);
                        increasePageViewCount();
                        console.log(2);
                    }


                } else {

                    increasePageViewCount();
                    console.log(3);
                }
            }
            catch (err)
            {
                increasePageViewCount();
                console.log(4);
            }
        }

        //increasePageViewCountEverySomeMinutes();
        function increasePageViewCountEverySomeMinutes() {
            var pageId = getPageId();
            if(pageId == undefined){
                return;
            }

            try{
                if(typeof(Storage) !== "undefined") {

                    var minuteInterval = 1;
                    var day = new Date();
                    var minute = day.getMinutes();
                    var item = "elitesoft.pageview.pageId-" + pageId;

                    if (localStorage.getItem(item)) {
                        var lastMinute = parseInt(localStorage.getItem(item));

                        if(lastMinute > minute){
                            lastMinute = lastMinute - 60;
                        }

                        if(lastMinute + minuteInterval <= minute){
                            increasePageViewCount();
                            localStorage.setItem(item, minute);
                            console.log("Set page view after interval");
                        }
                        else {
                            var increaseFlagItem = "elitesoft.pageview.increase.flag.pageId-" + pageId;
                            if(localStorage.getItem(increaseFlagItem) === "true"){
                                increasePageViewCount();
                                localStorage.setItem(item, minute);
                                console.log("Set page view by flag");
                            }
                        }

                    } else {
                        localStorage.setItem(item, minute);
                        increasePageViewCount();
                        console.log("Set page view first interval");
                    }


                } else {

                    increasePageViewCount();
                    console.log("Set page view no storage");
                }
            }
            catch (err)
            {
                increasePageViewCount();
                console.log("Set page view.");
            }
        }

        function getPageId(){

            var pageId = AJS.Meta.get("page-id");
            if(pageId === undefined)
            {
                // Use for scroll view port
                pageId = $("body").attr("pageid");
            }

            return pageId;
        }

        function createIncreasePageViewFlag(totalView, showPageView){
            var pageId = getPageId();
            if(pageId == undefined){
                return;
            }

            try{
                if(typeof(Storage) !== "undefined") {

                    var item = "elitesoft.pageview.increase.flag.pageId-" + pageId;

                    //Increase page view immediately for page has less than 50 views
                    if(showPageView == true && totalView < 50){
                        localStorage.setItem(item, true);
                    }
                    else {
                        localStorage.setItem(item, false);
                    }
                }
            }
            catch (err){
            }
        }

        $("#page-metadata-banner #view-banner-stats").click(function(e){
            e.preventDefault();

            if($("#page-metadata-banner #view-banner-stats span.show-detail").length == 0){
                return;
            }
            openPageViewDetail();
        });

        $(".page-metadata .page-metadata-modification-info").on("click", "a.view-times", function(event){
            event.preventDefault();

            if($(".page-metadata .page-metadata-modification-info a.show-detail").length == 0){
                return;
            }
            openPageViewDetail();
        });

        function openPageViewDetail(){
            var pageId = getPageId(); //AJS.Meta.get("page-id");
            var spaceKey = getSpaceKey(); //AJS.Meta.get("space-key");
            window.location.href = AJS.contextPath() + "/page-tracking/page-view-detail.action?pageId=" + pageId + "&spaceKey=" + spaceKey;
        }

        // Enable or disable page tracking on this page
        /*$("body").on("click", "#page-tracking-enable", function(event){
            event.preventDefault();

            var pageId = AJS.Meta.get("page-id");
            if(pageId === undefined){
                return;
            }
            var status = false;

            if($(this).hasClass("enable")){
                $(this).removeClass("enable").addClass("disable").html("Enable tracking");
                $("#page-tracking-table").hide();
                status = false;
            }
            else {
                $(this).removeClass("disable").addClass("enable").html("Disable tracking");
                $("#page-tracking-table").show();
                status = true;
            }

            $.ajax({
                cache: false,
                data: {pageId: pageId, status : status},
                dataType: "json",
                type: "PUT",
                error: function(jqXHR, textStatus, errorThrown) {
                    console.log("ERROR: " + pageId)
                },
                success: function(data) {
                    if(data.status){
                        console.log(pageId);
                    }
                },
                timeout: PageTrackingUtils.ajaxTimeout,
                url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/update-tracking-status")
            });
        });

        var pageTrackingDialog;
        function showpageTrackingDialog(pageId){
            if(pageTrackingDialog == null || pageTrackingDialog === undefined)
            {
                var width = window.innerWidth > 900? 900 : window.innerWidth;
                var height = window.innerHeight > 550 ? 600 : window.innerHeight;

                pageTrackingDialog = new AJS.Dialog({width : width, height : height,
                    id : "page-tracking-dialog", closeOnOutsideClick: true});
                pageTrackingDialog.addPanel("", "", "page-tracking-panel");

                pageTrackingDialog.addButton('Close', function(){
                    if($("#page-tracking-enable").hasClass("disable")){
                        window.location.reload();
                    }
                    pageTrackingDialog.hide();
                });

                var dialogBody = pageTrackingDialog.getCurrentPanel().body;

                $("<div class='message-box'></div>").appendTo(dialogBody);
                $("<div class='loading-box'></div>").appendTo(dialogBody);
                $("<div class='result-box'></div>").appendTo(dialogBody);

            }

            var loadingIcon = "<img src='" +
                Confluence.getContextPath() +
                '/download/resources/com.elitesoftsp.confluence.page.tracking.plugins:page-tracking-main-res/images/loading.gif'
                + "' >"

            pageTrackingDialog.show();

            loadPages();

            function loadPages() {

                var dialogBody = pageTrackingDialog.getCurrentPanel().body;

                var messageBox = $('.message-box', dialogBody);
                var loadingBox = $('.loading-box', dialogBody);
                var resultBox = $('.result-box', dialogBody);
                loadingBox.html(loadingIcon);

                $.ajax({
                    cache: false,
                    data: {pageId: pageId},
                    dataType: "json",
                    error: function (XMLHttpRequest, textStatus, errorThrown) {
                        if (XMLHttpRequest.status === 401) {
                            location.reload();
                        }
                    },
                    success: function (data) {

                        var result = "";

                        var header = "<div><h3>" + AJS.Meta.get("page-title") + "</h3>";

                        header += "<div><div style='float: right'>";
                        //Administrator and space admin can disable page tracking
                        if(data.spaceAdmin){
                            header +="<a href='#' id='page-tracking-enable' class='aui-button aui-button-link enable'>Disable tracking</a> | ";

                            var mapUrl = Confluence.getContextPath() + "/page-tracking/map-views.action?pageId=" + pageId;
                            if(data.showMap){
                                header += "<a href='" + mapUrl + "' target='_blank' title='View map'>Map</a> | ";
                            }

                            var trendUrl = Confluence.getContextPath() + "/page-tracking/trend-views.action?pageId=" + pageId;
                            header += "<a href='" + trendUrl + "' target='_blank' title='View trend'>Trend</a> | ";

                        }
                        header +="<a href='" + Confluence.getContextPath() + "/rest/page-tracking-services/1.0/page-tracking/page-viewers.xlsx?pageId=" + pageId +"'>Export</a>";
                        header +="</div></div></div>";

                        result += header;

                        if (data.status == true && data.pages.length > 0) {

                            var pages = data.pages;

                            result +="<table id='page-tracking-table' class='aui'><thead><tr><th>#</th><th>Name</th><th>Views</th><th>Last viewed</th><th></th></tr></thead><tbody>";

                            for(var i = 0; i < pages.length; i ++){
                                var row ="";
                                var userLink = pages[i].viewer;// "Anonymous";
                                if(pages[i].viewer != "Anonymous" && pages[i].viewer != "Authorized User") {
                                    userLink = "<a href='"
                                        + Confluence.getContextPath() + "/display/~" + pages[i].viewer +
                                        "' class='confluence-userlink' data-username='" + pages[i].viewer +
                                        "' target='_blank' >" + PageTrackingUtils.escapeHtml(pages[i].viewerFullName) + "</a>"
                                }

                                row += "<tr>";

                                row += "<td>" + (i + 1)  + "</td>";

                                row += "<td>" + userLink  + "</td>";

                                row += "<td>" + pages[i].timesViewed  + "</td>";

                                row += "<td>" + pages[i].lastViewed  + "</td>";

                                row += "<td>" + ""  + "</td>";

                                row+="</tr>";

                                result += row;
                            }

                            result +="</tbody></table>";
                        }

                        if(data.valid == false){
                            messageBox.html("<div class='aui-message aui-message-warning'><p>Page View requires a valid licence. Please ask your administrator(s) to create or update a licence.</p></div>");
                            resultBox.html("");
                            loadingBox.html("");
                            return;

                        }

                        loadingBox.html("");
                        resultBox.html(result).fadeIn("slow");

                        try{
                            AJS.Confluence.Binder.userHover();
                        }catch (err)
                        {}
                    },
                    type: "GET",
                    timeout: PageTrackingUtils.ajaxTimeout,
                    url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/page-view")
                });
            };
        }*/


        increaseBlogLandingView();
        function increaseBlogLandingView() {

            $(".view-blogposts .blog-post-listing").mouseover(function() {

                var addedClass = "page-view-statistics";
                if($(this).hasClass(addedClass)){
                    return;
                }
                $(this).addClass(addedClass);

                var spaceKey = getSpaceKey(); //AJS.Meta.get("space-key");
                var replacedString = AJS.contextPath() + "/display/" + spaceKey + "/";
                var aTag = $("a.blogHeading", this);
                var blogUrl = aTag.attr("href");
                var blogTitle = aTag.text();
                var index = blogUrl.indexOf(replacedString);

                if(index >= 0){
                    blogUrl = blogUrl.substring(index + replacedString.length - 1);
                }

                $.ajax({
                    cache: false,
                    data: {
                        spaceKey: spaceKey,
                        blogUrl: blogUrl,
                        blogTitle: blogTitle
                    },
                    dataType: "json",
                    type: "PUT",
                    error: function(jqXHR, textStatus, errorThrown) {
                        console.log("ERROR: " + blogUrl)
                    },
                    success: function(data) {

                    },
                    timeout: PageTrackingUtils.ajaxTimeout,
                    url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/blog-landing-view")
                });


            });

        }

        function increaseAttachmentView(attachmentData) {
            var spaceKey = getSpaceKey(); //AJS.Meta.get("space-key");
            var pageId = getPageId();// AJS.Meta.get("page-id");

            if(attachmentData === undefined){
                return;
            }

            var attachmentId = attachmentData.linkedResourceId;
            var version = attachmentData.linkedResourceVersion;

            $.ajax({
                cache: false,
                data: {
                    spaceKey: spaceKey,
                    pageId: pageId,
                    attachmentId: attachmentId,
                    version: version
                },
                dataType: "json",
                type: "PUT",
                error: function(jqXHR, textStatus, errorThrown) {

                },
                success: function(data) {

                },
                timeout: PageTrackingUtils.ajaxTimeout,
                url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/page-attachments")
            });
        }

        $(".confluence-embedded-image, a.confluence-embedded-file, a[data-linked-resource-id]").click(function (event) {

            if($(this).hasClass("previewAttachmentLink")){
                return;
            }

            var attachmentData = $(this).data();
            increaseAttachmentView(attachmentData);
        });

        // New Confluence file viewer
        $("body").on("click", "button.cp-nav-left.cp-nav, button.cp-nav-right.cp-nav", function(event){

            var fileTitle = $(".cp-file-title").text();
            var attachmentData = $('[data-linked-resource-default-alias="' + fileTitle + '"]').data();
            increaseAttachmentView(attachmentData);
        });

        // Old Confluence file viewer
        $("body").on("click", "#cp-nav-left.cp-nav, #cp-nav-right.cp-nav", function(event){

            var fileTitle = $(".cp-file-title").text();
            var attachmentData = $('[data-linked-resource-default-alias="' + fileTitle + '"]').data();
            increaseAttachmentView(attachmentData);
        });

        // Click on download button
        $("body").on("click", "a.cp-control-panel-download", function(event){

            var fileTitle = $(".cp-file-title").text();
            var attachmentData = $('[data-linked-resource-default-alias="' + fileTitle + '"]').data();
            increaseAttachmentView(attachmentData);
        });

        // Attachments macro
        $(".plugin_attachments_container .download-all-link").click(function (event) {

            var $attachmentTable = $(".plugin_attachments_container table.attachments");

            $(".attachment-row", $attachmentTable).each(function(){

                var attachmentId = $(this).data().attachmentId;
                var attachmentData = {
                    linkedResourceId : attachmentId,
                    linkedResourceVersion: 1
                };

                var attachmentHistoryData = $(".history-" + attachmentId, $attachmentTable).data();
                if(attachmentHistoryData != undefined){
                    attachmentData.linkedResourceVersion = attachmentHistoryData.attachmentVersion;
                }

                increaseAttachmentView(attachmentData);
            });
        });

        // Click on file name
        $(".filename-column .filename").click(function (event) {

            var attachmentId = $(this).closest("tr.attachment-row").data().attachmentId;
            var attachmentData = {
                linkedResourceId : attachmentId,
                linkedResourceVersion: 1
            };

            var $attachmentTable = $(".plugin_attachments_container table.attachments");
            var attachmentHistoryData = $(".history-" + attachmentId, $attachmentTable).data();
            if(attachmentHistoryData != undefined){
                attachmentData.linkedResourceVersion = attachmentHistoryData.attachmentVersion;
            }

            increaseAttachmentView(attachmentData);
        });

        // Click on file version
        $(".plugin_attachments_container table.attachments").on("click", ".attachment-version .filename", function(event){

            var attachmentId = $(this).closest("tr.attachment-summary").data().attachmentId;
            var attachmentData = {
                linkedResourceId : attachmentId,
                linkedResourceVersion: 1
            };

            var attachmentHistoryData = $(this).closest(".history-" + attachmentId).data();
            if(attachmentHistoryData != undefined){
                attachmentData.linkedResourceVersion = attachmentHistoryData.attachmentVersion;
            }

            increaseAttachmentView(attachmentData);
        });


        //Preview and View button
        $(".plugin_attachments_container table.attachments .attachment-buttons .aui-button").click(function (event) {

            var attachmentData;
            if($(this).hasClass("previewAttachmentLink")){
                attachmentData = $(this).data();
            }
            else {

                var $prevButton = $(this).prev();
                if($prevButton.hasClass("previewAttachmentLink")){
                    attachmentData = $prevButton.data();
                }
            }

            var attachmentId = attachmentData.linkedResourceId;
            var $attachmentTable = $(".plugin_attachments_container table.attachments");
            var attachmentHistoryData = $(".history-" + attachmentId, $attachmentTable).data();
            if(attachmentHistoryData != undefined){
                attachmentData.linkedResourceVersion = attachmentHistoryData.attachmentVersion;
            }

            increaseAttachmentView(attachmentData);
        });

        // At target for uncreated link
        $(".plugin_attachments_container table.attachments .attachment-row").click(function (event) {

            var attachmentId = $(this).data().attachmentId;
            setTimeout(function(){

                $(".attachment-summary-" + attachmentId + " .filename").each(function(){

                    var target = $(this).attr("target");
                    if(target === undefined){
                        $(this).attr("target", "_blank");
                    }
                });

            }, 2000);

        });

        changeTargetForFile();
        function changeTargetForFile() {

            var $attachmentTable = $(".plugin_attachments_container table.attachments");

            $(".filename", $attachmentTable).attr("target", "_blank");

            $(".attachment-buttons a.aui-button", $attachmentTable).each(function(){
                var href = $(this).attr("href");
                if(href !== undefined && href.indexOf("worddav/preview.action") > -1){
                    $(this).attr("target", "_blank");
                }
            });
        }

        function getSpaceKey(){

            var spaceKey = AJS.Meta.get("space-key");
            if(spaceKey !== undefined){
                return spaceKey;
            }

            spaceKey = $("body").attr("current-space-key");
            return spaceKey;
        }

        checkLicenseStatus();
        function checkLicenseStatus() {

            var bodyEl = $("body");
            if(!bodyEl.hasClass("page-view") && !bodyEl.hasClass("page-tracking")){
                return;
            }

            try{
                if(typeof(Storage) !== "undefined") {

                    var day = new Date();
                    var hour = day.getHours();
                    var item = "confluence.app.feature.discovery.auto";
                    var lastHour = localStorage.getItem(item);

                    if(lastHour === undefined || lastHour != hour ){
                        localStorage.setItem(item, hour);

                        $.ajax({
                            cache: false,
                            data: {},
                            dataType: "json",
                            error: function (XMLHttpRequest, textStatus, errorThrown) {

                            },
                            success: function (data) {

                                if(!data.v){
                                    var error = "Page Views requires a valid licence. Please ask your administrator(s) to create or update a licence.";
                                    $("#page-content").html(error);
                                    $(".page-tracking .wiki-content").html(error);

                                    localStorage.setItem(item, -1);
                                }


                            },
                            type: "GET",
                            timeout: PageTrackingUtils.ajaxTimeout,
                            url: PageTrackingUtils.getPageUtilityServiceBaseUrl("/system-activity")
                        });
                    }
                }
            }
            catch (err){

            }
        }


    });
}(AJS.$));

var PageTrackingUtils = {
    ajaxTimeout : 360000,
    getRestBaseUrl : function() {
        return Confluence.getContextPath() + "/rest/page-tracking-services/1.0";
    },
    getPageUtilityServiceBaseUrl : function(relativePath) {
        return this.getRestBaseUrl() + "/page-tracking" + relativePath;
    },
    escapeHtml : function (text) {
        'use strict';
        if(text === undefined){
            text = "";
        }
        return text.replace(/[\"&'\/<>]/g, function (a) {
            return {
                '"': '&quot;', '&': '&amp;', "'": '&#39;',
                '/': '&#47;',  '<': '&lt;',  '>': '&gt;'
            }[a];
        });
    }
}